; Detección de colisiones
org     $8000

; -----------------------------------------------------------------------------
; Entrada al programa
; -----------------------------------------------------------------------------
Main:
ld      a, $00                  ; A = 0
out     ($fe), a                ; Pone el borde en negro

call    Cls                     ; Limpia la pantalla
call    PrintLine               ; Imprime la línea central
call    PrintBorder             ; Imprime el borde del campo

Loop:
ld      a, (countLoopBall)      ; Carga el contador de vueltas de la bola	
inc     a                       ; Lo incrementa
ld      (countLoopBall), a      ; Lo carga en memoria
cp      $06                     ; Comprueba si ha llegado a 6
jr      nz, loop_paddle         ; Si no ha llegado a 6 salta
call    MoveBall                ; Mueve la bola
ld      a, ZERO                 ; Pone el contador a 0
ld      (countLoopBall), a      ; Lo carga en memoria

loop_paddle:
ld      a, (countLoopPaddle)    ; Carga el contador de vueltas de las palas
inc     a                       ; Lo incrementa
ld      (countLoopPaddle), a    ; Lo carga en memoria
cp      $02                     ; Comprueba si ha llegado a 2
jr      nz, loop_continue       ; Si no ha llegado a 2 salta
call    ScanKeys                ; Escanea las teclas pulsadas
call    MovePaddle              ; Mueva las palas
ld      a, ZERO                 ; Pone el contador a 0
ld      (countLoopPaddle), a    ; Lo carga en memoria

loop_continue:
call    CheckBallCross          ; Evalúa si hay colisión entre la bola y las palas
call    PrintBall               ; Pinta la bola
call    ReprintLine             ; Repinta la línea
ld      hl, (paddle1pos)        ; Carga en HL la posición de la pala 1
call    PrintPaddle             ; Pinta la pala 1
ld      hl, (paddle2pos)        ; Carga en HL la posición de la pala 2
call    PrintPaddle             ; Pinta la pala 2
jr      Loop                    ; Bucle infinito

include "Game.asm"
include "Controls.asm"
include "Sprite.asm"
include "Video.asm"

countLoopBall:      db $00      ; Contador de vueltas de la bola
countLoopPaddle:    db $00      ; Contador de vueltas de las palas

end     $8000